package com.flyer.foster.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.flyer.foster.dto.UserSearchDTO;
import com.flyer.foster.entity.User;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 用户表 Mapper 接口
 * </p>
 *
 * @author flyer
 * @since 2024-05-06
 */
public interface IUserMapper extends BaseMapper<User> {
    /**
     * 分页查询用户信息及用户的角色信息
     *
     * @param page     分页对象
     * @param queryDTO 查询对象
     * @return 分页数据集
     */
    IPage<UserSearchDTO> selectByPage(@Param("page") IPage<User> page, @Param("queryDTO") UserSearchDTO queryDTO);

    /**
     * 组织机构管理员分页列表
     *
     * @param page
     * @param searchDTO
     * @param userIdList
     * @return
     */
    IPage<UserSearchDTO> adminListByPage(@Param("page") IPage<UserSearchDTO> page,
                                         @Param("searchDTO") UserSearchDTO searchDTO,
                                         @Param("userIdList") List<Integer> userIdList);

    /**
     * 物理删除
     *
     * @param idList
     * @return
     */
    boolean deleteByIdList(@Param("idList") List<Integer> idList, @Param("tenantId") Integer tenantId);
}
