package com.flyer.foster.service;

import cn.hutool.crypto.asymmetric.RSA;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.flyer.foster.dto.LoginDTO;
import com.flyer.foster.dto.UserAddDto;
import com.flyer.foster.dto.UserAddOrUpdateDTO;
import com.flyer.foster.dto.UserSearchDTO;
import com.flyer.foster.entity.User;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 用户表 服务类
 * </p>
 *
 * @author flyer
 * @since 2024-05-06
 */
public interface IUserService extends IService<User> {
    /**
     * 获取RSA的公钥
     *
     * @param username 登录账号
     * @return
     */
    String getRsaKey(String username);

    /**
     * 登录
     *
     * @param loginDto
     * @return
     */
    String login(LoginDTO loginDto);

    /**
     * 多表查询用户信息
     *
     * @return list
     */
    IPage<UserSearchDTO> selectByPage(IPage<User> page, UserSearchDTO queryDTO);

    /**
     * 物理删除
     * @param idList
     * @return
     */
    boolean removeByIdList(List<Integer> idList);

    boolean addUser(UserAddDto addDTO);
}
